# evSoc
Python evSoc, derived from EVNotipi and EVNotify

evSoc can be installed directly on the RPi of the openWB wallbox.
evSoc can be installed on separate Server HW (Pi Zero) as a gateway between EV and openWB (option).

evSoc will provide the StateOfCharge SoC of the Electric Vehicle EV via bluetooth OBD Dongle.
All EVNotipi-Files Version 1.0.0 for supported CARS and DONGLES should remain unchanged (cloned from EVNotipi))

This installation is valid for evSoc Version 2.3, written at 19 August 2021

## Needed Hardware within garage (Option)
- Raspberry Pi Zero
- housing for Zero
- power supply for Zero

## Needed Hardware within EV
- ELM327 based OBD-Dongle for bluetooth (tested with TonWon BTS3.0 + EV Kona)

## Installation
### Raspberry Pi
- sudo apt update
- sudo apt upgrade
- sudo apt install python3-{pip,rpi.gpio,serial,requests,sdnotify,pyroute2,smbus,yaml,gevent} gpsd git watchdog rsyslog-

### evSoc
#### UNPACK evSoc.tar files into /opt/evSoc with root-permissions
- cd /opt/evSoc
- sudo pip3 install -r requirements.txt
- sudo pip3 install paho-mqtt
- sudo systemctl link /opt/evSoc/evSoc.service
- sudo systemctl enable evSoc.service

### Setup the Bluetooth Connection to OBD-Dongle
- sudo bluetoothctl
	power on
	agent on
	default-agent
	scan on
#### find your ID xx:xx:xx:xx:xx:xx
	pair xx:xx:xx:xx:xx:xx
	trust xx:xx:xx:xx:xx:xx
	scan off
	quit

### Customize to your environment
- edit /opt/evSoc/config.yaml
      - MQTT-Server address, if you do not run evSoc directly on the openWB-RPI
      - bluetooth MAC-address xx:xx:xx:xx:xx:xx
      - type of your car

### openWB
#### Configure @ web-interface -> Chargingpoint configuration -> "SOC Modul" = MQTT

### OPTION
#### Setup WiFi connection of PI Zero to the openWB

## Manual Start
- sudo systemctl start evSoc.service

## DEBUGGING
easist way is to stop the service via 
  sudo systemctl stop evSoc.servive
and start debugging mode via command line:
  cd /opt/evSoc
  sudo ./evSoc.py -d

## Home-server integration
evSoc will pause its interface to the bluetooth dongle, if the car is not charged.
this is necessary in order to avoid exhausted 12V battery.
evSoc resumes as soon as the charge-cable is plugged OR the charging is re-activated by the wallbox (e.g., for PV-ONLY chargin mode)

hence, if the EV comes home and is not plugged in, typically no SoC is available.
however, you could then immediately restart evSoc manually in order to enforce an SoC update.

For more sophisticated applications, the mqtt based home server interface can restart evSoc as well:
Whenever a non-zero value is detected in mqtt topic "evSoc/carport/boolOpenStat", evSoc restarts.
A homeserver might provide this value whenever the door of the garage is opened - or a photo sensor or presence sensor is activated.
A zero value indicates, that the car port is closed! The topic must toggle between zero and non-zero values!
