from car import *

# This is OUTLANDER interface

cmd = bytes.fromhex('2101')         # PID command
canIDtx=0x761                       # Transmit CAN ID
canIDrx=0x762                       # Receive CAN ID
index=2                             # index of SoC in received message

class OUTL_EV(Car):

    def __init__(self, config, dongle, gps):
        Car.__init__(self, config, dongle, gps)
        self.dongle.setProtocol('CAN_11_500')

    def readDongle(self, data):
        now = time()
        raw = {}

        cmds = (('ATFCSH761','OK'),
                ('ATFCSD300000','OK'),
                ('ATFCSM1','OK'))

        for c,r in cmds:
            self.dongle.sendAtCmd(c, r)

        raw[cmd] = self.dongle.sendCommandEx(cmd, canrx=canIDrx, cantx=canIDtx)

# test print for soc raw value
#       print(hex(raw[cmd][index]))

        data.update({
            'SOC_DISPLAY':              raw[cmd][index] / 2.0 - 5,
         })

