from car import *

# This is a template for new EV types
# example tested with KONA(2018) EV

cmd = bytes.fromhex('220105')       # PID command
canIDtx=0x7e4                       # Transmit CAN ID
canIDrx=0x7ec                       # Receive CAN ID
index=34                            # index of SoC in received message for Kona

# how to calculate the index value:
# received example:
#                                 2E <- length of payload    
#DEBUG:EVNotiPi/AtBaseDongle:7EC102E620105003FFF first frame
#DEBUG:EVNotiPi/AtBaseDongle:7EC2190000000000000 consecutive frame
#DEBUG:EVNotiPi/AtBaseDongle:7EC2200001179030042 consecutive frame
#DEBUG:EVNotiPi/AtBaseDongle:7EC23683E1C00416410 consecutive frame
#DEBUG:EVNotiPi/AtBaseDongle:7EC244603E800000000 consecutive frame
#                                  60 <- SoC value
#DEBUG:EVNotiPi/AtBaseDongle:7EC25460000B4B40000 consecutive frame
#DEBUG:EVNotiPi/AtBaseDongle:7EC260F00000000AAAA consecutive frame

# decimal count index values included here instead of data payload
#                                   00 <- Index value dec(00)
#     :EVNotiPi/AtBaseDongle:xxx10yy000102030405 first frame
#     :EVNotiPi/AtBaseDongle:xxx2106070809101112 consecutive frame
#     :EVNotiPi/AtBaseDongle:xxx2213141516171819 consecutive frame
#     :EVNotiPi/AtBaseDongle:xxx2320212223242526 consecutive frame
#     :EVNotiPi/AtBaseDongle:xxx2427282930313233 consecutive frame
#                                 34 <- SoC index in decimal
#     :EVNotiPi/AtBaseDongle:xxx2534353637383940 consecutive frame
#     :EVNotiPi/AtBaseDongle:xxx2641424344454647 consecutive frame
# xxx=canIDrx
# yy = length [hex(2E)=dec(47)]

class TEMP_EV(Car):

    def __init__(self, config, dongle, gps):
        Car.__init__(self, config, dongle, gps)
        self.dongle.setProtocol('CAN_11_500')

    def readDongle(self, data):
        now = time()
        raw = {}

        raw[cmd] = self.dongle.sendCommandEx(cmd, canrx=canIDrx, cantx=canIDtx)

# test print for soc raw value
        print(hex(raw[cmd][index]))

        data.update({
            # You might have to adopt the formula below for propper calculation
            'SOC_DISPLAY':              raw[cmd][index] / 2.0,
         })

